#!/bin/bash
#
# Filesystem Checksum Tool (fschksum) - hack using the readdir accelator hack
# by Theodore Ts'o which is contained in the e2fsprogs/contrib/ source directory
#
# Copyright 2021,2022 Christian Schneider <software(at)chschneider(dot)eu>
#
# This file is part of the Filesystem Checksum Tool (fschksum)
# (called "program" in the following).
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation, *not* any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

## current directory
DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" >/dev/null 2>&1 && pwd)"

## the pre-loaded file
SOFILE="${DIR}/spd_readdir.so"
if [[ ! -f ${SOFILE} ]]; then
  ( cd "${DIR}" && gcc -o spd_readdir.so -shared -fpic spd_readdir.c -ldl )
fi

if [[ ! -f ${SOFILE} ]]; then
  echo "ERROR: ${SOFILE} could not be generated." >&2
  exit 1
fi

LD_PRELOAD="${SOFILE}" "${DIR}/fschksum" "${@}"
